

\pset pager off 
\timing



drop table if exists donations_hash ;

create table donations_hash (
CMTE_ID varchar,
AMNDT_IND varchar,
RPT_TP varchar,
TRANSACTION_PGI varchar,
IMAGE_NUM varchar,
TRANSACTION_TP varchar,
ENTITY_TP varchar,
NAME varchar,
CITY varchar,
STATE varchar,
ZIP_CODE varchar,
EMPLOYER varchar,
OCCUPATION varchar,
TRANSACTION_DT varchar,
TRANSACTION_AMT varchar,
OTHER_ID varchar,
TRAN_ID varchar,
FILE_NUM varchar,
MEMO_CD varchar,
MEMO_TEXT varchar,
SUB_ID varchar
) partition by hash(NAME);

\copy donations_hash from 'indiv20/by_date/itcont_2020_20010425_20190425.txt' delimiter '|';
  
create table donations_hash_1 partition of donations_hash FOR VALUES WITH (MODULUS 4, REMAINDER 0);
create table donations_hash_2 partition of donations_hash FOR VALUES WITH (MODULUS 4, REMAINDER 1);
create table donations_hash_3 partition of donations_hash FOR VALUES WITH (MODULUS 4, REMAINDER 2);
create table donations_hash_4 partition of donations_hash FOR VALUES WITH (MODULUS 4, REMAINDER 3);

create table donations2_hash (
CMTE_ID varchar,
AMNDT_IND varchar,
RPT_TP varchar,
TRANSACTION_PGI varchar,
IMAGE_NUM varchar,
TRANSACTION_TP varchar,
ENTITY_TP varchar,
NAME varchar,
CITY varchar,
STATE varchar,
ZIP_CODE varchar,
EMPLOYER varchar,
OCCUPATION varchar,
TRANSACTION_DT varchar,
TRANSACTION_AMT varchar,
OTHER_ID varchar,
TRAN_ID varchar,
FILE_NUM varchar,
MEMO_CD varchar,
MEMO_TEXT varchar,
SUB_ID varchar
) partition by hash(NAME);

create table donations2_hash_1 partition of donations2_hash FOR VALUES WITH (MODULUS 4, REMAINDER 0);
create table donations2_hash_2 partition of donations2_hash FOR VALUES WITH (MODULUS 4, REMAINDER 1);
create table donations2_hash_3 partition of donations2_hash FOR VALUES WITH (MODULUS 4, REMAINDER 2);
create table donations2_hash_4 partition of donations2_hash FOR VALUES WITH (MODULUS 4, REMAINDER 3);

\copy donations2_hash  from 'indiv20/by_date/itcont_2020_20190426_20190628.txt' delimiter '|';

\timing

set enable_mergejoin=false;
SET max_parallel_workers_per_gather = 4;

select count(*) from donations_hash d join donations2_hash d2 on d.NAME = d2.NAME;
#Time: 3520.703 ms (00:03.521)

SET max_parallel_workers_per_gather = 0;
#Time: 9587.248 ms (00:09.587)

SET max_parallel_workers_per_gather = 4;

select count(*) from donations d join donations2 d2 on d.NAME = d2.NAME;
#Time: 15242.292 ms (00:15.242)

